progname=exercise_06_28
CC=g++
CFLAGS=-Wall -Wextra -Werror -g3

all: test1 test2 test3

debug:
	mkdir -p debug

debug/$(progname): debug/$(progname).o
	$(CC) $(CFLAGS)  $<  -o  $@

debug/%.o: debug/%.s
	$(CC) -c $(CFLAGS) $<  -o $@

debug/%.s: debug/%.ii
	$(CC) -S $(CFLAGS) $<  -o $@

debug/%.ii: %.cpp
	$(CC) -E  $(CFLAGS)  $<  -o $@

clean:
	rm -r debug *.out

test%: debug | debug/$(progname) 
	./debug/$(progname) < $@.in > $@.out || echo "Test 1 is executing..."
	diff $@.out $@.expected && echo PASSED || echo FAILED

.PRECIOUS: $(progname).ii  $(progname).s
.SECONDARY: $(progname).ii  $(progname).s

